const fs = require('fs');
const path = require('path');
const cp = require('child_process');

const configName = 'deploy.js';
const cwd = path.join(process.cwd(), '../..'); // eslint-disable-line
const deploySrc = path.join(__dirname, configName);
const deployDest = path.join(cwd, configName);

const readFile = filepath => fs.readFileSync(filepath, { encoding: 'utf8' });

// Create deploy config if it doesn't exists
try {
  readFile(deployDest);
} catch (err) {
  cp.execSync(`cp ${deploySrc} ${deployDest}`);
}

// Add `deploy` as an npm script
try {
  const packageJson = readFile(`${cwd}/package.json`);
  const parsedPackageJson = JSON.parse(packageJson);
  const packageJsonScripts = Object.assign({}, parsedPackageJson.scripts, {
    deploy: 'iframe-eb-deploy',
  });

  parsedPackageJson.scripts = packageJsonScripts;

  fs.writeFileSync(
    `${cwd}/package.json`,
    JSON.stringify(parsedPackageJson, null, 2)
  );
} catch (err) {} // eslint-disable-line